 /*-------------------------------------------------------------------*/
 /*                                                                   */
 /* SAS for Mixed Models, Second Edition                              */
 /* by Ramon C. Littell, George A. Milliken, Walter W. Stroup,        */
 /*    Russell D. Wolfinger, Oliver Schabenberger                     */
 /* Copyright (c) 2006 by SAS Institute Inc., Cary, NC, USA           */
 /* SAS Publications order   1-59047-500-3                            */
 /*                                                                   */
 /*-------------------------------------------------------------------*/
 /*                                                                   */
 /* This material is provided "as is" by SAS Institute Inc.  There    */
 /* are no warranties, expressed or implied, as to merchantability or */
 /* fitness for a particular purpose regarding the materials or code  */
 /* contained herein. The Institute is not responsible for errors     */
 /* in this material as it now exists or will exist, nor does the     */
 /* Institute provide technical support for it.                       */
 /*                                                                   */
 /*-------------------------------------------------------------------*/
 /* Date Last Updated: 31JAN06                                        */
 /*-------------------------------------------------------------------*/
 /* Questions or problem reports concerning this material may be      */
 /* addressed to the authors:                                         */
 /*                                                                   */
 /* SAS Institute Inc.                                                */
 /* SAS Press                                                         */
 /* Attn: Ramon C. Littell, George A. Milliken, Walter W. Stroup,     */
 /*       Russell D. Wolfinger, Oliver Schabenberger                  */
 /* SAS Campus Drive                                                  */
 /* Cary, NC   27513                                                  */
 /*                                                                   */
 /* If you prefer, you can send e-mail to:  saspress@sas.com          */
 /* Use this for subject field:                                       */
 /*    Comments for Ramon C. Littell, George A. Milliken,             */
 /*    Walter W. Stroup, Russell D. Wolfinger, Oliver Schabenberger   */ 
 /*                                                                   */
 /*-------------------------------------------------------------------*/


 /*-------------------------------------------------------*/
 /*---Notes                                            ---*/ 
 /*---                                                 ---*/
 /*---This file contains the SAS code for SAS for      ---*/
 /*---Mixed Models, Second Edition.                    ---*/
 /*---To run the code for the book successfully,       ---*/
 /*---you need the following                           ---*/
 /*---                                                 ---*/
 /*---  1) SAS 9.1 (or 9.1.2, 9.1.3) with the modules  ---*/
 /*---     SAS/BASE                                    ---*/
 /*---     SAS/STAT                                    ---*/
 /*---     SAS/GRAPH                                   ---*/
 /*---     SAS/IML (for Chapter 12 only)               ---*/
 /*---     licensed and installed                      ---*/
 /*---                                                 ---*/
 /*---  2) In SAS 9.1, to run examples that contain    ---*/
 /*---     PROC GLIMMIX code, you need to download     ---*/
 /*---     PROC GLIMMIX from www.sas.com/statistics    ---*/
 /*---     and install it. PROC GLIMMIX in SAS 9.1     ---*/
 /*---     requires a standalone installation of SAS   ---*/
 /*---     on the 32-bit Windows platform              ---*/
 /*---                                                 ---*/
 /*---The code is organized by chapters.               ---*/
 /*---                                                 ---*/
 /*---Many programs make use of the ODS SELECT state-  ---*/
 /*---ment in order to reduce the procedure output     ---*/
 /*---to what is shown in the book. For example,       ---*/
 /*---                                                 ---*/
 /*---    Output 4.21                                  ---*/
 /*---      proc mixed data=variety_eval;              ---*/
 /*---        class block type dose;                   ---*/
 /*---        model y=type logdose(type) ld_sq /noint  ---*/
 /*---                     ddfm=satterth solution;     ---*/
 /*---        random block block*dose;                 ---*/
 /*---        ods select SolutionF;                    ---*/
 /*---      run;                                       ---*/
 /*---                                                 ---*/
 /*---To see the full output of the procedure,         ---*/
 /*---remove the ODS SELECT statements.                ---*/
 /*-------------------------------------------------------*/

 /*-------------------------------------------------------*/
 /*---CHAPTER 11: Spatial Variability                  ---*/
 /*-------------------------------------------------------*/

 /*-------------------------------------------------------*/
 /*---Data Set 11.5, Uniformity Trial                  ---*/
data spatvar;
   input rep bloc row col yield;
   datalines;
1    4   1   1     10.5411
1    4   1   2      8.5806
1    2   1   3     11.2790
1    2   1   4     12.4344
1    4   2   1     10.3416
1    4   2   2     11.3103
1    2   2   3      9.0282
1    2   2   4      9.7985
1    3   3   1     10.4939
1    3   3   2     11.2576
1    1   3   3      7.3720
1    1   3   4      6.0833
1    3   4   1      9.8869
1    3   4   2      8.2849
1    1   4   3      7.2836
1    1   4   4      8.0018
2    7   5   1     10.3349
2    7   5   2      9.9135
2    6   5   3      8.1662
2    6   5   4     10.7679
2    7   6   1     12.1580
2    7   6   2     11.0230
2    6   6   3      9.2912
2    6   6   4      9.1392
2    5   7   1     13.1097
2    5   7   2     10.0121
2    8   7   3      8.2482
2    8   7   4      7.3975
2    5   8   1     11.0226
2    5   8   2     10.7690
2    8   8   3      6.2206
2    8   8   4      6.5696
3   12   1   5     11.1944
3   12   1   6      7.9737
3   11   1   7      5.8400
3   11   1   8      6.9580
3   12   2   5     10.2561
3   12   2   6      9.8180
3   11   2   7     10.3009
3   11   2   8      7.4719
3    9   3   5     10.1148
3    9   3   6      9.6252
3   10   3   7      8.7800
3   10   3   8     11.2786
3    9   4   5      7.9548
3    9   4   6      6.1100
3   10   4   7      8.6507
3   10   4   8      9.2237
4   16   5   5     10.3129
4   16   5   6      7.3161
4   13   5   7      8.6394
4   13   5   8      7.8669
4   16   6   5      9.0250
4   16   6   6      7.2483
4   13   6   7     10.0104
4   13   6   8     10.0473
4   14   7   5      7.0507
4   14   7   6     11.1225
4   15   7   7     12.0253
4   15   7   8     10.4298
4   14   8   5      7.3220
4   14   8   6     10.5104
4   15   8   7     12.6808
4   15   8   8     10.4482
;
 /*-------------------------------------------------------*/
 
 /*-------------------------------------------------------*/
 /*---Output 11.1                                      ---*/
title 'no nugget - spherical covariance model';
proc mixed data=spatvar;
   model yield = ;
   repeated / subject = intercept 
              type    = sp(sph)(row col);
   parms (0 to 10 by 2.5) 
         (1 to 10 by 3  );
   ods select ParmSearch CovParms IterHistory 
              ConvergenceStatus FitStatistics LRT;
run;
 /*-------------------------------------------------------*/

 /*-------------------------------------------------------*/
 /*---Output 11.2                                      ---*/
title 'no nugget - exponential covariance model';
proc mixed data=spatvar;
   model yield = ;
   repeated / subject = intercept 
              type    = sp(exp)(row col);
   parms (0 to 10 by 2.5) 
         (1 to 10 by 3  );
   ods select CovParms FitStatistics;
run;
proc mixed data=spatvar;
   model yield = ;
   repeated / subject = intercept 
              type    = sp(gau)(row col);
   parms (0 to 10 by 2.5) 
         (1 to 10 by 3  );
   ods select CovParms FitStatistics;
run;
 /*-------------------------------------------------------*/

 /*-------------------------------------------------------*/
 /*---Output 11.3                                      ---*/
title 'rcb error model';
proc mixed data=spatvar;
   class rep;
   model yield = ;
   random rep;
   ods select CovParms FitStatistics;
run;
    
title 'incomplete block error model';
proc mixed data=spatvar;
   class bloc;
   model yield = ;
   random bloc;
   ods select CovParms FitStatistics;
run;
 /*-------------------------------------------------------*/

 /*-------------------------------------------------------*/
 /*---Outpuyt 11.4 a                                   ---*/
title 'nugget effect - exponential covariance model';
proc mixed data=spatvar; 
   model yield = ;
   repeated / subject = intercept 
              type    = sp(exp)(row col)
              local;
   parms (0    to 10    by 2.5 ) 
         (1    to 10    by 3   ) 
         (0.05 to  1.05 by 0.25);
   ods select IterHistory ConvergenceStatus CovParms;
run;
 /*-------------------------------------------------------*/

 /*-------------------------------------------------------*/
 /*---Outpuyt 11.4 b                                   ---*/
title 'nugget effect - exponential covariance model';
proc mixed data=spatvar convg=1e-7; 
   model yield = ;
   repeated / subject = intercept 
              type    = sp(exp)(row col)
              local;
   parms (0    to 10    by 2.5 ) 
         (1    to 10    by 3   ) 
         (0.05 to  1.05 by 0.25);
   ods select IterHistory ConvergenceStatus CovParms;
run;
 /*-------------------------------------------------------*/

 /*-------------------------------------------------------*/
 /*---Output 11.5                                      ---*/
data spatvar; set spatvar;
  obs = _n_;
run;
proc mixed data=spatvar convg=1e-7;
   class obs;
   model yield = ;
   random obs / type=sp(exp)(row col);
   parms (0    to 10   by 2.5 ) 
         (1    to 10   by 3   ) 
         (0.05 to 1.05 by 0.25);
   ods select Dimensions IterHistory ConvergenceStatus 
              FitStatistics CovParms;
run;
 /*-------------------------------------------------------*/

 /*-------------------------------------------------------*/
 /*---Data Set 11.6, Hazardous Waste                   ---*/
data a;
   input easting northing logt salt xxx $;
   if logt=1e31 or logt<-10 then delete;
   if salt=1e31 then delete;
   datalines;
16.442  18.128 -6.02895   28.6   H-1
15.670  18.095 -6.20046   26.9   H-2b1
16.748  17.339 -5.60886   -0.6   H-3b1
15.399  14.927 -5.99598    0     H-4b
19.891  21.245 -7.01145   1E31   H-5b
13.613  21.452 -4.44995   -0.6   H-6b
11.143  11.092 -2.81246  -37.1   H-7b
11.702       0 -5.05465  -19.9   H-8b
17.008   4.705 -3.90188      0   H-9b
25.994   8.917 -7.12337      0   H-10b
18.365  15.574 -4.50570   1E31   H-11b1
20.042  11.896 -6.71319  100.3   H-12
15.36   16.798 -6.48422   1E31   H-14
18.334  18.303 -6.88042   1E31   H-15
16.388  18.656 -6.11491   32.8   H-16
18.737  13.957 -6.63614   64.6   H-17
15.283  19.61  -5.77751   27.4   H-18
18.222  16.777 -4.92707   1E31   DOE-1
16.702  21.738 -4.01908   1E31   DOE-2
15.357  16.785   1E+31    24.3   P-1
18.335  18.292   1E+31    31.1   P-2
15.818  18.342   1E+31    29.9   P-3
17.954  16.763   1E+31    31.7   P-4
16.703  19.984   1E+31    29.6   P-5
13.628  17.528   1E+31    -0.5   P-6
15.327  14.922   1E+31    20.7   P-7
16.849  14.911   1E+31    33.2   P-8
18.375  15.569   1E+31    31.4   P-9
20.106  17.647   1E+31     114   P-10
20.035  19.901   1E+31    30.5   P-11
13.475  19.896   1E+31    -0.9   P-12
13.55   21.473   1E+31    -1.2   P-13
12.10   18.42  -3.55706   -2.4   P-14
13.643  15.191 -7.03535     25   P-15
15.714  13.765   1E+31    28.6   P-16
16.945  13.91  -5.96847   34.4   P-17
21.386  16.794 -10.1233  132.2   P-18
20.7    18.862   1E+31    69.36  P-19
21.551  20.212   1E+31    30.8   P-20
19.917  21.293   1E+31    30.2   P-21
16.81   22.919   1E+31       0   WIPP-11
16.729  19.968 -6.96847   29.9   WIPP-12
15.663  20.691 -4.12962      0   WIPP-13
16.754  19.623 -6.49134   30.3   WIPP-18
16.758  19.226 -6.19031      0   WIPP-19
16.762  18.763 -6.57053   29.9   WIPP-21
16.758  19.097 -6.40026   29.8   WIPP-22
 9.404  20.472 -3.54116  -10.7   WIPP-25
 7.033  17.606 -2.91359   -3.3   WIPP-26
 7.445  29.523 -3.36921    -28   WIPP-27
14.285  31.124 -4.6839   -17.7   WIPP-28
 0      15.138 -2.96847  -32.9   WIPP-29
16.74   26.145 -6.60227      0   WIPP-30
12.649  20.463   1E+31    1E31   WIPP-33
17.353  21.586   1E+31    1E31   WIPP-34
21.239  25.452   1E+31    -0.1   ERDA-6
16.715  18.402 -6.29637   26.7   ERDA-9
 9.704   6.959   1E+31   -15.2   ERDA-10
16.21   14.493 -6.52131   1E31   C-B1
17.972   3.898 -4.33500   1E31   ENGLE
 9.481   5.903 -3.25842   1E31   USGS-1
 8.86    6.331   1E+31    1E31   USGS-4
 8.898   6.332   1E+31    1E31   USGS-8
11.721  15.321 -5.68971   1E31   D-268
24.145  25.825 -6.55349   18.7   AEC-7
20.544  22.886   1E+31       0   AEC-8
14.714  17.053   1E+31    -0.3   B-25
16.736  18.524   1E+31    1E31   EX. SHAFT
10.48   26.499   1E+31    1E31   FFG-107
 2.258   8.668   1E+31    1E31   FFG-153
 4.878    9.65   1E+31    1E31   FFG-165
 7.234   5.137   1E+31    1E31   FFG-181
 6.9    -0.971   1E+31    1E31   FFG-188*
32.296  33.411   1E+31    1E31   FFG-225*
23.873   33.47   1E+31    1E31   FFG-236
30.198  25.776   1E+31    1E31   FFG-244*
-4.458   28.01   1E+31    1E31   FFG-426*
-1.181  21.666   1E+31    1E31   1 DANF
 4.331   25.36   1E+31    1E31   1 DUNC
;
 /*-------------------------------------------------------*/

 /*-------------------------------------------------------*/
 /*---Output 11.6                                      ---*/
proc mixed data=a; 
   model logt = salt / solution;
   repeated / subject = intercept 
              type    = sp(exp)(easting northing)
              local;
   parms (1   to  7   by 3  )
         (2   to 17   by 5  ) 
         (0.1 to  0.5 by 0.2);
   ods select CovParms FitStatistics SolutionF Tests3;
run;
 /*-------------------------------------------------------*/


 /*-------------------------------------------------------*/
 /*---Data Set 11.7, Wheat Yield                       ---*/
data alliance;
   input Entry $ 1-22 variety_id 23-24 plot 26-29 RawYield 36-42 Rep 45-46
         LOC $ 47-49 NLOC  50-51 Yield 53-59 LAT 67-68 LNG 75-77;
   Latitude  = 4.3*LAT;
   Longitude = 1.2*LNG;
   if variety_id=. then delete;
   datalines;
    LANCER             1 1101       585.00   1    4  29.250        1       16
    BRULE              2 1102       631.00   1    4  31.550        1       17
    REDLAND            3 1103       701.00   1    4  35.050        1       18
    CODY               4 1104       602.00   1    4  30.100        1       19
    ARAPAHOE           5 1105       661.00   1    4  33.050        1       20
    NE83404            6 1106       605.00   1    4  30.250        1       21
    NE83406            7 1107    1  704.00   1    4  35.200        1       22
    NE83407            8 1108       388.00   1    4  19.400        2        1
    CENTURA            9 1109       487.00   1    4  24.350        2        2
    SCOUT 66          10 1110       511.00   1    4  25.550        2        3
    COLT              11 1111       502.00   1    4  25.100        2        4
    NE83498           12 1112       492.00   1    4  24.600        2        5
    NE84557           13 1113       509.00   1    4  25.450        2        6
    NE83432           14 1114       268.00   1    4  13.400        2        7
    NE85556           15 1115       633.00   1    4  31.650        2        8
    NE85623           16 1116       513.00   1    4  25.650        2        9
    CENTURK 78        17 1117       632.00   1    4  31.600        2       10
    NORKAN            18 1118       446.00   1    4  22.300        2       11
    KS831374          19 1119       684.00   1    4  34.200        2       12
    TAM 200           20 1120       422.00   1    4  21.100        2       13
    NE86482           21 1121       560.00   1    4  28.000        2       14
    HOMESTEAD         22 1122       566.00   1    4  28.300        2       15
    LANCOTA           23 1123       514.00   1    4  25.700        2       16
    NE86501           24 1124       635.00   1    4  31.750        2       17
    NE86503           25 1125       840.00   1    4  42.000        2       18
    NE86507           26 1126       618.00   1    4  30.900        2       19
    NE86509           27 1127       658.00   1    4  32.900        2       20
    TAM 107           28 1128       481.00   1    4  24.050        2       21
    CHEYENNE          29 1129    1  564.00   1    4  28.200        2       22
    BUCKSKIN          30 1130       597.00   1    4  29.850        3        1
    NE86527           31 1131       580.00   1    4  29.000        3        2
    NE86582           32 1132       418.00   1    4  20.900        3        3
    NE86606           33 1133       526.00   1    4  26.300        3        4
    NE86607           34 1134       517.00   1    4  25.850        3        5
    ROUGHRIDER        35 1135       479.00   1    4  23.950        3        6
    VONA              36 1136       506.00   1    4  25.300        3        7
    SIOUXLAND         37 1137       542.00   1    4  27.100        3        8
    GAGE              38 1138       513.00   1    4  25.650        3        9
    NE83T12           39 1139       504.00   1    4  25.200        3       10
    NE86T666          40 1140       368.00   1    4  18.400        3       11
    NE87403           41 1141       437.00   1    4  21.850        3       12
    NE87408           42 1142       540.00   1    4  27.000        3       13
    NE87409           43 1143       631.00   1    4  31.550        3       14
    NE87446           44 1144       610.00   1    4  30.500        3       15
    NE87451           45 1145       639.00   1    4  31.950        3       16
    NE87457           46 1146       611.00   1    4  30.550        3       17
    NE87463           47 1147       545.00   1    4  27.250        3       18
    NE87499           48 1148       598.00   1    4  29.900        3       19
    NE87512           49 1149       656.00   1    4  32.800        3       20
    NE87513           50 1150       557.00   1    4  27.850        3       21
    NE87522           51 1151    1  486.00   1    4  24.300        3       22
    NE87612           52 1152       563.00   1    4  28.150        4        1
    NE87613           53 1153       539.00   1    4  26.950        4        2
    NE87615           54 1154       502.00   1    4  25.100        4        3
    NE87619           55 1155       605.00   1    4  30.250        4        4
    NE87627           56 1156    1  403.00   1    4  20.150        4        5
    RC                                                 .           4        6
    CENTURA            9 2101       556.00   2    4  27.800        4        7
    NE85623           16 2102       569.00   2    4  28.450        4        8
    CODY               4 2103       455.00   2    4  22.750        4        9
    NE86582           32 2104       534.00   2    4  26.700        4       10
    NE87408           42 2105       513.00   2    4  25.650        4       11
    NE87451           45 2106       549.00   2    4  27.450        4       12
    NE83432           14 2107       620.00   2    4  31.000        4       13
    CENTURK 78        17 2108       498.00   2    4  24.900        4       14
    NE83T12           39 2109       513.00   2    4  25.650        4       15
    NE87409           43 2110       648.00   2    4  32.400        4       16
    NE87513           50 2111       624.00   2    4  31.200        4       17
    NE87627           56 2112       552.00   2    4  27.600        4       18
    ARAPAHOE           5 2113       693.00   2    4  34.650        4       19
    LANCER             1 2114       570.00   2    4  28.500        4       20
    TAM 107           28 2115       589.00   2    4  29.450        4       21
    REDLAND            3 2116    1  611.00   2    4  30.550        4       22
    VONA              36 2117       536.00   2    4  26.800        5        1
    NE87463           47 2118       477.00   2    4  23.850        5        2
    NE86507           26 2119       548.00   2    4  27.400        5        3
    BUCKSKIN          30 2120       602.00   2    4  30.100        5        4
    ROUGHRIDER        35 2121       495.00   2    4  24.750        5        5
    NE86527           31 2122       507.00   2    4  25.350        5        6
    SCOUT 66          10 2123       520.00   2    4  26.000        5        7
    NE86509           27 2124       500.00   2    4  25.000        5        8
    NE86606           33 2125       587.00   2    4  29.350        5        9
    NE84557           13 2126       572.00   2    4  28.600        5       10
    KS831374          19 2127       534.00   2    4  26.700        5       11
    GAGE              38 2128       505.00   2    4  25.250        5       12
    NE87619           55 2129       675.00   2    4  33.750        5       13
    NE87499           48 2130       446.00   2    4  22.300        5       14
    CHEYENNE          29 2131       561.00   2    4  28.050        5       15
    NE86607           34 2132       691.00   2    4  34.550        5       16
    NE83498           12 2133       748.00   2    4  37.400        5       17
    NE83404            6 2134       580.00   2    4  29.000        5       18
    NE87446           44 2135       624.00   2    4  31.200        5       19
    SIOUXLAND         37 2136       742.00   2    4  37.100        5       20
    HOMESTEAD         22 2137       590.00   2    4  29.500        5       21
    NE86501           24 2138    1  627.00   2    4  31.350        5       22
    NE87512           49 2139       404.00   2    4  20.200        6        1
    NE83407            8 2140       528.00   2    4  26.400        6        2
    NE87403           41 2141       513.00   2    4  25.650        6        3
    NE87457           46 2142       638.00   2    4  31.900        6        4
    NE83406            7 2143       621.00   2    4  31.050        6        5
    COLT              11 2144       615.00   2    4  30.750        6        6
    NE87522           51 2145       543.00   2    4  27.150        6        7
    NORKAN            18 2146       606.00   2    4  30.300        6        8
    NE87615           54 2147       634.00   2    4  31.700        6        9
    NE85556           15 2148       610.00   2    4  30.500        6       10
    TAM 200           20 2149       487.00   2    4  24.350        6       11
    LANCOTA           23 2150       522.00   2    4  26.100        6       12
    NE86503           25 2151       599.00   2    4  29.950        6       13
    NE86482           21 2152       656.00   2    4  32.800        6       14
    BRULE              2 2153       563.00   2    4  28.150        6       15
    NE87612           52 2154       654.00   2    4  32.700        6       16
    NE87613           53 2155       738.00   2    4  36.900        6       17
    NE86T666          40 2156    1  368.00   2    4  18.400        6       18
    RC                                                 .           6       19
    NE86607           34 3101       623.00   3    4  31.150        6       20
    LANCOTA           23 3102       539.00   3    4  26.950        6       21
    NE87513           50 3103    1  616.00   3    4  30.800        6       22
    NE87408           42 3104       438.00   3    4  21.900        7        1
    NE83407            8 3105       592.00   3    4  29.600        7        2
    NORKAN            18 3106       485.00   3    4  24.250        7        3
    REDLAND            3 3107       542.00   3    4  27.100        7        4
    KS831374          19 3108       421.00   3    4  21.050        7        5
    COLT              11 3109       479.00   3    4  23.950        7        6
    NE86527           31 3110       546.00   3    4  27.300        7        7
    VONA              36 3111       600.00   3    4  30.000        7        8
    TAM 107           28 3112       690.00   3    4  34.500        7        9
    CENTURK 78        17 3113       662.00   3    4  33.100        7       10
    NE87627           56 3114       564.00   3    4  28.200        7       11
    NE86T666          40 3115       516.00   3    4  25.800        7       12
    NE87615           54 3116       679.00   3    4  33.950        7       13
    NE86501           24 3117       607.00   3    4  30.350        7       14
    NE87522           51 3118       378.00   3    4  18.900        7       15
    CHEYENNE          29 3119       678.00   3    4  33.900        7       16
    SIOUXLAND         37 3120       675.00   3    4  33.750        7       17
    NE87451           45 3121       679.00   3    4  33.950        7       18
    GAGE              38 3122       500.00   3    4  25.000        7       19
    LANCER             1 3123       562.00   3    4  28.100        7       20
    NE87446           44 3124       500.00   3    4  25.000        7       21
    NE86482           21 3125    1  606.00   3    4  30.300        7       22
    CODY               4 3126       337.00   3    4  16.850        8        1
    NE87612           52 3127       342.00   3    4  17.100        8        2
    NE87457           46 3128       191.00   3    4   9.550        8        3
    NE84557           13 3129        30.00   3    4   1.500        8        4
    NE83T12           39 3130       255.00   3    4  12.750        8        5
    NE86507           26 3131       443.00   3    4  22.150        8        6
    TAM 200           20 3132       384.00   3    4  19.200        8        7
    NE87613           53 3133       471.00   3    4  23.550        8        8
    ARAPAHOE           5 3134       501.00   3    4  25.050        8        9
    SCOUT 66          10 3135       665.00   3    4  33.250        8       10
    NE87403           41 3136       480.00   3    4  24.000        8       11
    NE85623           16 3137       635.00   3    4  31.750        8       12
    NE86509           27 3138       481.00   3    4  24.050        8       13
    NE85556           15 3139       769.00   3    4  38.450        8       14
    HOMESTEAD         22 3140       517.00   3    4  25.850        8       15
    NE83404            6 3141       656.00   3    4  32.800        8       16
    NE86503           25 3142       702.00   3    4  35.100        8       17
    NE86582           32 3143       621.00   3    4  31.050        8       18
    NE87619           55 3144       663.00   3    4  33.150        8       19
    NE87463           47 3145       580.00   3    4  29.000        8       20
    NE86606           33 3146       643.00   3    4  32.150        8       21
    BRULE              2 3147    1  818.00   3    4  40.900        8       22
    BUCKSKIN          30 3148       360.00   3    4  18.000        9        1
    NE83406            7 3149        43.00   3    4   2.150        9        2
    NE87409           43 3150        75.00   3    4   3.750        9        3
    NE87499           48 3151        59.00   3    4   2.950        9        4
    CENTURA            9 3152       174.00   3    4   8.700        9        5
    NE83432           14 3153       221.00   3    4  11.050        9        6
    NE87512           49 3154       247.00   3    4  12.350        9        7
    ROUGHRIDER        35 3155       449.00   3    4  22.450        9        8
    NE83498           12 3156    1  538.00   3    4  26.900        9        9
    RC                                                 .           9       10
    NE86T666          40 4101       471.00   4    4  23.550        9       11
    NE87403           41 4102       580.00   4    4  29.000        9       12
    NE87512           49 4103       553.00   4    4  27.650        9       13
    NE87446           44 4104       480.00   4    4  24.000        9       14
    CENTURA            9 4105       515.00   4    4  25.750        9       15
    NE86503           25 4106       471.00   4    4  23.550        9       16
    NE87408           42 4107       613.00   4    4  30.650        9       17
    COLT              11 4108       564.00   4    4  28.200        9       18
    LANCER             1 4109       568.00   4    4  28.400        9       19
    NE83406            7 4110       574.00   4    4  28.700        9       20
    NE86607           34 4111       515.00   4    4  25.750        9       21
    SIOUXLAND         37 4112    1  450.00   4    4  22.500        9       22
    NE87612           52 4113       185.00   4    4   9.250       10        1
    BUCKSKIN          30 4114       486.00   4    4  24.300       10        2
    NE85556           15 4115        99.00   4    4   4.950       10        3
    BRULE              2 4116        74.00   4    4   3.700       10        4
    NE86507           26 4117       294.00   4    4  14.700       10        5
    ROUGHRIDER        35 4118       272.00   4    4  13.600       10        6
    VONA              36 4119       246.00   4    4  12.300       10        7
    NE83404            6 4120       350.00   4    4  17.500       10        8
    CODY               4 4121       303.00   4    4  15.150       10        9
    NE87463           47 4122       471.00   4    4  23.550       10       10
    NE86582           32 4123       390.00   4    4  19.500       10       11
    NE87499           48 4124       530.00   4    4  26.500       10       12
    NORKAN            18 4125       416.00   4    4  20.800       10       13
    SCOUT 66          10 4126       506.00   4    4  25.300       10       14
    NE87513           50 4127       348.00   4    4  17.400       10       15
    NE83T12           39 4128       453.00   4    4  22.650       10       16
    CENTURK 78        17 4129       632.00   4    4  31.600       10       17
    NE87627           56 4130       339.00   4    4  16.950       10       18
    NE86606           33 4131       625.00   4    4  31.250       10       19
    NE87457           46 4132       473.00   4    4  23.650       10       20
    NE86509           27 4133       509.00   4    4  25.450       10       21
    LANCOTA           23 4134    1  549.00   4    4  27.450       10       22
    KS831374          19 4135       291.00   4    4  14.550       11        1
    NE86482           21 4136       121.00   4    4   6.050       11        2
    NE85623           16 4137        21.00   4    4   1.050       11        3
    NE86527           31 4138       128.00   4    4   6.400       11        4
    NE87451           45 4139       102.00   4    4   5.100       11        5
    NE87409           43 4140       356.00   4    4  17.800       11        6
    GAGE              38 4141       443.00   4    4  22.150       11        7
    NE83407            8 4142       307.00   4    4  15.350       11        8
    NE87615           54 4143       240.00   4    4  12.000       11        9
    ARAPAHOE           5 4144       500.00   4    4  25.000       11       10
    CHEYENNE          29 4145       442.00   4    4  22.100       11       11
    REDLAND            3 4146       586.00   4    4  29.300       11       12
    NE83432           14 4147       469.00   4    4  23.450       11       13
    NE87619           55 4148       558.00   4    4  27.900       11       14
    NE83498           12 4149       632.00   4    4  31.600       11       15
    NE87613           53 4150       604.00   4    4  30.200       11       16
    NE86501           24 4151       606.00   4    4  30.300       11       17
    TAM 200           20 4152       406.00   4    4  20.300       11       18
    NE87522           51 4153       593.00   4    4  29.650       11       19
    NE84557           13 4154       531.00   4    4  26.550       11       20
    TAM 107           28 4155       512.00   4    4  25.600       11       21
    HOMESTEAD         22 4156    1  538.00   4    4  26.900       11       22
;
 /*-------------------------------------------------------*/
 

 /*-------------------------------------------------------*/
 /*---Figure 11.2                                      ---*/
proc mixed data=alliance;
   class Rep Entry;
   model Yield = Entry / outp=residuals;
   random Rep;
run;
proc variogram data=residuals outvar=plot_variogram;
   coordinates xc=lng yc=lat;
   compute lagd=1.2 maxlags=50;
   var resid;
run;
 /*---This code produces Figure 11.2 with SAS 9.1      ---*/
 /*---This template code is specific for SAS 9.1       ---*/
 /*---ODS graphics are experimental in SAS 9.1 and the ---*/
 /*---template syntax is different in subsequent releases-*/ 
proc template;
   define statgraph svartemplate;
      layout overlay / yaxisopts=(ticks=(0 50 100 150));
           scatterplot  y=variog x=distance /
                markersymbol = GraphDataDefault:markersymbol
                markercolor  = GraphDataDefault:contrastcolor
                markersize   = GraphDataDefault:markersize;
      endlayout;
   end;
run;
ods html; 
ods graphics on;
title;
data _null_;
    set plot_variogram;
    label variog='Semivariogram';
    file print ods=(template='svartemplate');
    put _ods_;
run;
ods graphics off;
ods html close;
 /*-------------------------------------------------------*/

 /*-------------------------------------------------------*/
 /*---Output 11.7a                                     ---*/
proc mixed data=alliance;
   class Entry Rep;
   model Yield = entry / ddfm=kr;
   random Rep;
   repeated / subject=intercept 
              type=sp(sph)(latitude longitude) local;
   ods select CovParms;
run;
 /*-------------------------------------------------------*/

 /*-------------------------------------------------------*/
 /*---Output 11.7b                                     ---*/
proc mixed data=alliance;
   class Entry Rep;
   model Yield = Entry /ddfm=kr;
   random Rep;
   repeated / subject=intercept 
              type=sp(sph)(latitude longitude);
   parms (9.88 18 45);
   ods select CovParms FitStatistics Tests3;
run;
 /*-------------------------------------------------------*/

 /*-------------------------------------------------------*/
 /*---Output 11.7c                                     ---*/
proc mixed data=alliance;
   class Entry Rep;
   model Yield = entry / ddfm=kr;
   random Rep;
   repeated / subject=intercept 
              type=sp(sph)(latitude longitude) local;
   parms (1 18 18 25); 
   estimate 'arap v brul' entry 1 -1  0;
   estimate 'arap v buck' entry 1  0 -1 0;
   estimate 'arap v ks83' entry 1  0  0 0 0 0 0 0 0 0 -1 0;
   estimate 'brul v ks83' entry 0  1  0 0 0 0 0 0 0 0 -1 0; 
   ods select CovParms FitStatistics Tests3 Estimates;
run;
 /*-------------------------------------------------------*/

 /*-------------------------------------------------------*/
 /*---Output 11.8                                      ---*/
data variogram1;
  set plot_variogram;
  if distance <= 35;
  if lag=-1 then distance=0;
run;
proc nlin data=variogram1;
    parms r=18 nugget=17 sill=25;
    model variog = nugget + 
           sill*(1.5*distance/r-0.5*(distance/r)**3)*(distance<r) +
           sill*(distance>=r); 
    /*   
        model covar=nugget*(distance=0) + sill*(1-1.5*distance/r + 
        0.5*(distance/r)**3)*(distance<r);
    */
run;
 /*-------------------------------------------------------*/
 
 /*-------------------------------------------------------*/
 /*---Output 11.9                                      ---*/
proc mixed data=alliance noprofile;
   class Entry rep;
   model Yield = entry / ddfm=kr;
   repeated / subject=intercept 
              type=sp(sph)(latitude longitude) local;
   parms (25.453 24.277 17.069) / noiter;
  /* parms (20.057  13.974 16.684)/noiter;  */
  ods select CovParms FitStatistics Tests3;
run;
 /*-------------------------------------------------------*/

 /*-------------------------------------------------------*/
 /*---Output 11.10                                     ---*/
ods exclude all;
proc mixed data=alliance;
   class rep Entry;
   model Yield = Entry;
   random rep;
   lsmeans Entry;
   ods output lsmeans=rcb;
run;
proc mixed data=alliance;
   class entry rep;
   model Yield = entry / ddfm=kr;
   random rep;
   repeated / subject=intercept
              type=sp(sph)(latitude longitude) local;
   parms (0.1 15 18 18);
   lsmeans Entry;
   ods output lsmeans=sph;
run;
proc mixed data=alliance noprofile;
   class Entry Rep;
   model Yield = entry / ddfm=kr;
   repeated / subject=intercept
              type=sp(sph)(latitude longitude) local;
   parms (25.453 24.277 17.069)/noiter;
   lsmeans Entry;
   ods output lsmeans=sph2;
run;
ods exclude none;

data rcb1;
   set rcb(keep=entry estimate stderr rename=(estimate=rcb stderr=se_rcb));
   label rcb='LS-Mean RCB';
run;

proc rank data=rcb1 descending out=rcb_rank;
   var rcb;
   ranks rcb_rank;
run;

data sph1;
   set sph(keep=entry estimate stderr rename=(estimate=sph stderr=se_sph));
   label sph='LS-Mean SPH';
run;

proc rank data=sph1 descending out=sph_rank;
   var sph;
   ranks sph_rank;
run;

data sph2;
   set sph2(keep=entry estimate stderr rename=(estimate=sph2 stderr=se_sph2));
   label sph2='LS-Mean SPH2';
run;

proc rank data=sph2 descending out=sph2_rank;
   var sph2;
   ranks sph2_rank;
run;

proc sort data=rcb_rank;  by entry;
proc sort data=sph_rank;  by entry;
proc sort data=sph2_rank; by entry;
run;

data ranks; 
   merge rcb_rank sph_rank sph2_rank;
   by entry;
   label rcb_rank ='Rank of LS-Mean in RCB Model'
         sph_rank ='Rank of LS-Mean in Spherical Model'
         sph2_rank='Rank of LS-Mean in Spherical Model (noiter)';
run;

proc sort data=ranks;
   by rcb_rank;
run;

proc print data=ranks(obs=37) noobs label;
  var Entry rcb_rank rcb sph_rank sph sph2_rank sph2;
run;
 /*-------------------------------------------------------*/


 /*-------------------------------------------------------*/
 /*---Figure 11.3                                      ---*/
 /*---This template code is specific for SAS 9.1       ---*/
 /*---ODS graphics are experimental in SAS 9.1 and the ---*/
 /*---template syntax is different in subsequent releases-*/ 
proc template;
   define statgraph temp;
      layout lattice / rows=2 columns=1 rowgutter=15;
          layout lattice / rows=1 columns=2 columngutter=25;
              scatterplot  x=rcb    y=sph;    
              scatterplot  x=sph2   y=sph;
          endlayout;
          layout overlay;
              scatterplot  x=se_sph2 y=se_sph;
              lineparm slope=0 yintercept=3.85569 /
                       linecolor     = black
                       linethickness = 2
                       linepattern   = solid
                       extreme       = true;
          endlayout;
      endlayout;
   end;
run;
title;
ods html; 
ods graphics on;
data _null_;
    set ranks;
    label rcb     = 'LS-Mean RCB'
          sph2    = 'LS-Mean SPH'
          sph     = 'LS-Mean SPH REML'
          se_rcb  = 'StdErr  RCB'
          se_sph  = 'StdErr SPH REML'
          se_sph2 = 'StdErr SPH';
    file print ods=(template='temp');
    put _ods_;
run;
ods graphics off;
ods html close;
 /*-------------------------------------------------------*/


 /*-------------------------------------------------------*/
 /*---Data Set 11.8, C-N Ratios                        ---*/
data CNRatio;
  input x y TN TC CN;
  datalines;
  0     35.0    0.0810    0.9225    11.4201
  0     40.0    0.0790    0.8310    10.5300
  0     80.0    0.0800    0.8460    10.5750
  0    100.0    0.0705    0.7705    10.9451
  0    140.0    0.0915    0.9985    10.9132
  0    170.0    0.0855    0.9015    10.5427
  0    185.0    0.0745    0.8445    11.3654
  0    235.0    0.0670    0.6925    10.3396
  0    245.0    0.0600    0.5980     9.9667
  0    295.0    0.0610    0.6410    10.5113
  0    300.0    0.0580    0.5925    10.2155
  5     35.0    0.0880    0.9460    10.7640
  5     40.0    0.0785    0.8790    11.1974
  5    295.0    0.0650    0.6505    10.0077
  5    300.0    0.0570    0.5800    10.1813
 30     15.0    0.0770    0.8340    10.8312
 30     40.0    0.0690    0.7080    10.2660
 30     80.0    0.0860    0.9310    10.8263
 30    100.0    0.0765    0.8260    10.7962
 30    145.0    0.0990    1.0460    10.5665
 30    170.0    0.0875    0.9200    10.5133
 30    190.0    0.0740    0.7750    10.4748
 30    230.0    0.0740    0.7990    10.7973
 30    245.0    0.0675    0.7595    11.2648
 30    300.0    0.0585    0.6180    10.5812
 40    147.5    0.0985    1.0280    10.5327
 40    300.0    0.0550    0.5945    10.8091
 45     15.0    0.0900    0.9640    10.7223
 45     40.0    0.0760    0.8120    10.6836
 45    147.5    0.0815    0.8625    10.5883
 45    300.0    0.0390    0.3990    10.2308
 55     35.0    0.0920    0.9785    10.6254
 55     40.0    0.0805    0.9030    11.2184
 55    300.0    0.0600    0.6540    10.8960
 60     35.0    0.0820    0.8415    10.2739
 60     40.0    0.0805    0.8735    10.8447
 65    147.5    0.0925    1.0695    11.5640
 75     35.0    0.0730    0.8255    11.3061
 75     40.0    0.0800    0.8560    10.7237
 85     15.0    0.0775    0.8745    11.2875
 85     40.0    0.0720    0.8480    11.7778
 90     15.0    0.0750    0.8130    10.8542
 90     40.0    0.0750    0.8670    11.5600
100     27.5    0.0785    0.8245    10.5030
100     35.0    0.0740    0.8090    10.9642
100     75.0    0.0790    0.8525    10.7929
100     95.0    0.0610    0.6190    10.1475
100    145.0    0.0890    0.9310    10.4621
100    170.0    0.0795    0.8830    11.1179
100    175.0    0.0890    0.9055    10.1756
100    230.0    0.0765    0.7875    10.2912
100    240.0    0.0795    0.8560    10.7661
100    300.0    0.0670    0.7225    10.7872
115     15.0    0.0735    0.7770    10.5718
115     20.0    0.0780    0.8485    10.8829
115     75.0    0.0770    0.8420    10.9386
115    102.5    0.0870    0.9260    10.6437
115    135.0    0.0830    0.9025    10.8999
115    180.0    0.0845    0.9080    10.7515
115    190.0    0.0745    0.7675    10.3198
115    230.0    0.0780    0.7885    10.1086
115    245.0    0.0630    0.6635    10.5472
115    287.5    0.0635    0.7060    11.1217
170     35.0    0.0750    0.8395    11.3085
170     40.0    0.0905    0.9870    10.9053
170     85.0    0.0820    0.8690    10.5976
170    100.0    0.0820    0.8430    10.2827
170    145.0    0.1055    1.1750    11.1537
170    235.0    0.0625    0.6480    10.3910
170    240.0    0.0675    0.7040    10.4424
170    290.0    0.0725    0.7140     9.8487
180    300.0    0.0775    0.7790    10.0524
185    300.0    0.0765    0.8275    10.8195
190    170.0    0.0770    0.8670    11.2746
190    295.0    0.0725    0.7250    10.0421
200     30.0    0.0920    0.9895    10.7597
200     40.0    0.0955    1.0350    10.8457
200     80.0    0.0825    0.8240     9.9880
200     90.0    0.0700    0.7000    10.0094
200    140.0    0.0845    0.9080    10.7592
200    175.0    0.0750    0.8025    10.7092
200    190.0    0.0645    0.6545    10.1653
200    240.0    0.0675    0.6650     9.8513
200    250.0    0.0620    0.6020     9.7135
200    295.0    0.0810    0.8155    10.0684
205    175.0    0.0645    0.7090    11.0082
205    190.0    0.0665    0.7490    11.2618
205    295.0    0.0760    0.8180    10.7632
210     80.0    0.0760    0.7625    10.0504
215    190.0    0.0715    0.7870    11.0346
215    295.0    0.0885    0.9195    10.4139
230     80.0    0.0930    0.9540    10.2581
230    155.0    0.0660    0.6920    10.4848
230    190.0    0.0705    0.8020    11.3737
230    295.0    0.0915    0.9450    10.3286
235     80.0    0.0875    0.8855    10.1301
235    180.0    0.0720    0.8170    11.3472
235    295.0    0.0865    0.9055    10.4767
245    145.0    0.0690    0.7515    10.9183
250     35.0    0.0900    0.9590    10.6771
250     40.0    0.0940    0.9955    10.5981
250     85.0    0.0850    0.9300    10.9565
250    100.0    0.0855    0.8975    10.4994
250    140.0    0.0815    0.8500    10.4325
250    170.0    0.0655    0.6790    10.3736
250    175.0    0.0765    0.7795    10.1982
250    180.0    0.0670    0.6820    10.1935
250    190.0    0.0530    0.4975     9.3920
250    235.0    0.0730    0.7535    10.3511
250    245.0    0.0715    0.7195    10.0840
250    300.0    0.0750    0.8115    10.8296
255    145.0    0.0650    0.7580    11.6615
260    145.0    0.0695    0.7720    11.1081
265     80.0    0.0950    0.9900    10.4311
275    145.0    0.0830    1.0080    12.1446
280     80.0    0.0945    0.9890    10.4682
290     80.0    0.0930    0.9660    10.3871
300     30.0    0.0710    0.7870    11.0845
300     40.0    0.0770    0.8930    11.6073
300     90.0    0.0775    0.8700    11.2799
300     95.0    0.0760    0.8270    10.9265
300    145.0    0.0945    1.0035    10.6244
300    175.0    0.0846    0.8876    10.4890
300    180.0    0.0720    0.7495    10.4136
300    295.0    0.0745    0.7695    10.3343
305     35.0    0.0770    0.9020    11.7174
305     40.0    0.0730    0.8480    11.6214
305     80.0    0.0875    0.9940    11.4114
305     87.5    0.0845    0.9755    11.5312
305    140.0    0.0855    0.9650    11.2849
305    170.0    0.0810    0.9430    11.6485
305    190.0    0.0757    0.8445    11.1628
315    145.0    0.0715    0.7970    11.2645
320    145.0    0.0710    0.8155    11.5447
325    235.0    0.0800    0.8505    10.6308
325    245.0    0.0790    0.9040    11.4347
335    145.0    0.0690    0.8250    11.9699
340     30.0    0.0785    0.8565    10.9172
340     40.0    0.0870    1.0020    11.5172
340     80.0    0.0960    1.0885    11.3384
340     87.5    0.0780    0.9030    11.5769
340    145.0    0.0740    0.8295    11.2134
340    180.0    0.0705    0.7980    11.3178
340    190.0    0.0695    0.7845    11.2886
340    230.0    0.0760    0.8270    10.8816
340    235.0    0.0815    0.8670    10.6424
340    245.0    0.0775    0.8910    11.4973
350    235.0    0.0775    0.8395    10.8347
350    240.0    0.0755    0.8230    10.9038
365    235.0    0.0850    0.9060    10.6588
365    245.0    0.0850    0.9285    10.9268
370    235.0    0.0810    0.8610    10.6364
370    245.0    0.0845    0.8585    10.1599
385    235.0    0.0875    0.8870    10.1403
385    245.0    0.0520    0.4875     9.3879
400     20.0    0.0635    0.7420    11.7024
400     40.0    0.0525    0.5905    11.2603
400     80.0    0.0750    0.8465    11.2867
400     90.0    0.0655    0.7128    10.9226
400    140.0    0.0870    1.0155    11.6749
400    175.0    0.0725    0.8045    11.1201
400    190.0    0.0690    0.7190    10.4203
400    230.0    0.0745    0.7980    10.7073
400    235.0    0.0830    0.9040    10.8924
400    290.0    0.0735    0.8055    10.9637
415     80.0    0.0630    0.6900    10.9833
415     90.0    0.0545    0.5810    10.6864
415    300.0    0.0795    0.7785     9.7940
420    300.0    0.0760    0.7580    10.0185
425     80.0    0.0535    0.5405    10.1075
425    100.0    0.0480    0.5538    11.5496
430     80.0    0.0645    0.6575    10.1908
430     95.0    0.0635    0.6560    10.3396
430    300.0    0.0725    0.7380    10.1811
440     80.0    0.0595    0.6415    10.8016
440    100.0    0.0570    0.5590     9.8070
450    300.0    0.0695    0.7080    10.1856
475     80.0    0.0675    0.7780    11.5232
475     90.0    0.0780    0.8710    11.1667
485    300.0    0.0700    0.7650    10.9286
495     35.0    0.0705    0.7655    10.8600
495     40.0    0.0795    0.9095    11.4328
495    295.0    0.0670    0.7230    10.8141
495    300.0    0.0636    0.7136    11.2067
500     35.0    0.0660    0.8120    12.3030
500     40.0    0.0701    0.8349    11.9036
500     80.0    0.0550    0.6300    11.4730
500     90.0    0.0680    0.7875    11.6313
500    147.5    0.0840    1.0310    12.2738
500    172.5    0.0675    0.7845    11.6202
500    192.5    0.0685    0.7415    10.8862
500    232.5    0.0690    0.7460    10.8615
500    247.5    0.0595    0.6925    11.6414
500    295.0    0.0695    0.7425    10.6915
500    300.0    0.0765    0.8735    11.4545
  0      5.0    0.1290    .    .
  0     10.0    0.1120    .    .
  0     50.0    0.0755    .    .
  0     65.0    0.0820    .    .
  0    115.0    0.0790    .    .
  0    130.0    0.0770    .    .
  0    155.0    0.0960    .    .
  0    205.0    0.0705    .    .
  0    215.0    0.0685    .    .
  0    260.0    0.0610    .    .
  0    265.0    0.0600    .    .
  5      5.0    0.1075    .    .
  5     10.0    0.1205    .    .
  5    260.0    0.0600    .    .
  5    265.0    0.0640    .    .
 30     10.0    0.0865    .    .
 30     50.0    0.0860    .    .
 30     65.0    0.0885    .    .
 30    105.0    0.0730    .    .
 30    130.0    0.0905    .    .
 30    155.0    0.0955    .    .
 30    210.0    0.0735    .    .
 30    215.0    0.0760    .    .
 30    260.0    0.0595    .    .
 30    265.0    0.0545    .    .
 40    155.0    0.0790    .    .
 40    265.0    0.0545    .    .
 45      5.0    0.1170    .    .
 45    155.0    0.0865    .    .
 45    265.0    0.0550    .    .
 55     10.0    0.0960    .    .
 55    265.0    0.0655    .    .
 60      5.0    0.0990    .    .
 65    155.0    0.0835    .    .
 75      0.0    0.0985    .    .
 85      0.0    0.0825    .    .
 90      5.0    0.0830    .    .
100     10.0    0.0690    .    .
100     47.5    0.0840    .    .
100     65.0    0.0795    .    .
100    105.0    0.0775    .    .
100    130.0    0.0950    .    .
100    155.0    0.0910    .    .
100    210.0    0.0755    .    .
100    215.0    0.0705    .    .
100    255.0    0.0690    .    .
100    285.0    0.0635    .    .
115     10.0    0.0725    .    .
115     50.0    0.0830    .    .
115     55.0    0.0770    .    .
115    107.5    0.0850    .    .
115    132.5    0.0825    .    .
115    162.5    0.0885    .    .
115    200.0    0.0810    .    .
115    210.0    0.0750    .    .
115    265.0    0.0608    .    .
170     10.0    0.0785    .    .
170     55.0    0.0810    .    .
170     60.0    0.0960    .    .
170    115.0    0.0870    .    .
170    130.0    0.0975    .    .
170    155.0    0.0910    .    .
170    215.0    0.0560    .    .
170    220.0    0.0620    .    .
170    270.0    0.0650    .    .
170    275.0    0.0670    .    .
180    260.0    0.0665    .    .
180    285.0    0.0680    .    .
185    260.0    0.0775    .    .
185    285.0    0.0640    .    .
190    155.0    0.0765    .    .
190    260.0    0.0765    .    .
190    270.0    0.0775    .    .
200     50.0    0.1050    .    .
200     55.0    0.0995    .    .
200    110.0    0.0880    .    .
200    120.0    0.0945    .    .
200    162.5    0.0770    .    .
200    200.0    0.0640    .    .
200    215.0    0.0615    .    .
200    260.0    0.0765    .    .
200    280.0    0.0790    .    .
205    155.0    0.0700    .    .
205    260.0    0.0775    .    .
205    270.0    0.0700    .    .
210     65.0    0.0900    .    .
215    155.0    0.0745    .    .
215    260.0    0.0740    .    .
215    270.0    0.0740    .    .
230     65.0    0.0940    .    .
230    155.0    0.0770    .    .
230    260.0    0.0740    .    .
230    280.0    0.0805    .    .
235     65.0    0.0990    .    .
235    155.0    0.0625    .    .
235    260.0    0.0755    .    .
235    280.0    0.0810    .    .
245    110.0    0.0775    .    .
245    125.0    0.0745    .    .
250     55.0    0.1040    .    .
250     65.0    0.0970    .    .
250    115.0    0.0510    .    .
250    120.0    0.0722    .    .
250    155.0    0.0420    .    .
250    205.0    0.0625    .    .
250    215.0    0.0700    .    .
250    265.0    0.0705    .    .
250    280.0    0.0640    .    .
255    115.0    0.0670    .    .
255    125.0    0.0730    .    .
260    110.0    0.0700    .    .
260    125.0    0.0708    .    .
265     65.0    0.1030    .    .
275    120.0    0.0660    .    .
275    125.0    0.0755    .    .
280     65.0    0.1075    .    .
285    115.0    0.0760    .    .
285    125.0    0.0675    .    .
290     65.0    0.1155    .    .
290    110.0    0.0650    .    .
290    125.0    0.0735    .    .
300     50.0    0.0840    .    .
300     65.0    0.1035    .    .
300    155.0    0.0930    .    .
300    265.0    0.0710    .    .
300    280.0    0.0755    .    .
305     10.0    0.0645    .    .
305     50.0    0.0835    .    .
305     60.0    0.0920    .    .
305    110.0    0.0795    .    .
305    130.0    0.0850    .    .
305    160.0    0.0860    .    .
305    260.0    0.0760    .    .
315    110.0    0.0710    .    .
315    125.0    0.0740    .    .
320    110.0    0.0710    .    .
320    125.0    0.0820    .    .
325    205.0    0.0705    .    .
325    210.0    0.0860    .    .
335    110.0    0.0795    .    .
335    125.0    0.0705    .    .
340     10.0    0.0855    .    .
340     50.0    0.0830    .    .
340     70.0    0.0950    .    .
340    110.0    0.0820    .    .
340    130.0    0.0770    .    .
340    155.0    0.0645    .    .
340    200.0    0.0715    .    .
340    205.0    0.0660    .    .
340    210.0    0.0765    .    .
340    265.0    0.0720    .    .
340    275.0    0.0685    .    .
350    205.0    0.0760    .    .
350    210.0    0.0815    .    .
365    205.0    0.0785    .    .
365    210.0    0.0725    .    .
370    205.0    0.0870    .    .
370    210.0    0.0800    .    .
385    205.0    0.0795    .    .
385    215.0    0.0905    .    .
400     10.0    0.0560    .    .
400     50.0    0.0630    .    .
400     60.0    0.0710    .    .
400    110.0    0.0696    .    .
400    115.0    0.0825    .    .
400    155.0    0.0740    .    .
400    200.0    0.0690    .    .
400    205.0    0.0760    .    .
400    260.0    0.0745    .    .
400    275.0    0.0825    .    .
415     50.0    0.0520    .    .
415     60.0    0.0650    .    .
415    275.0    0.0860    .    .
420    275.0    0.0835    .    .
425     50.0    0.0595    .    .
425     70.0    0.0601    .    .
430     50.0    0.0580    .    .
430     65.0    0.0690    .    .
430    275.0    0.0744    .    .
440     50.0    0.0525    .    .
440     65.0    0.0600    .    .
450    275.0    0.0685    .    .
475     50.0    0.0795    .    .
475     60.0    0.0710    .    .
485    275.0    0.0700    .    .
495      5.0    0.0685    .    .
495     10.0    0.0715    .    .
495    277.5    0.0635    .    .
495    282.5    0.0700    .    .
500      5.0    0.0885    .    .
500     10.0    0.0765    .    .
500     50.0    0.0790    .    .
500     60.0    0.0780    .    .
500    110.0    0.0730    .    .
500    132.5    0.0920    .    .
500    157.5    0.0790    .    .
500    202.5    0.0710    .    .
500    215.0    0.0655    .    .
500    277.5    0.0640    .    .
500    282.5    0.0630    .    .
;
  /*-------------------------------------------------------*/

 /*-------------------------------------------------------*/
 /*---Output 11.11                                     ---*/
data predlocs;
  do x=0 to 500 by 12.5;
     do y=0 to 300 by 7.5;
	    output;
     end;
  end;
run;
data fitthis; 
    set cnratio(where=(tc ne .)) predlocs;
run;
proc mixed data=fitthis;
   model cn = / outp=OKpredictions;
   repeated / subject=intercept type=sp(exp)(x y);
   ods select Dimensions NObs FitStatistics 
              ConvergenceStatus CovParms;
run;
 /*-------------------------------------------------------*/
 

 /*-------------------------------------------------------*/
 /*---Output 11.12a                                    ---*/
proc print data=OKpredictions(where=((x=100) and (y=300))); 
run;
 /*-------------------------------------------------------*/ 

 /*-------------------------------------------------------*/
 /*---Output 11.12b                                    ---*/
proc print data=OKpredictions(where=(x=100)); 
run;
 /*-------------------------------------------------------*/ 

 /*-------------------------------------------------------*/
 /*---Output 11.13                                     ---*/
proc mixed data=cnratio;
   model tc = tn / solution outp=UKpredictions;
   repeated / subject = intercept 
              type    = sp(expa)(x y);
   ods select Dimensions NObs CovParms SolutionF;
run;
 /*-------------------------------------------------------*/

 /*-------------------------------------------------------*/
 /*---Output 11.14                                     ---*/
proc print data=UKPredictions(where=(x=5));
   var x y TC TN Pred StdErrPred;
run;
 /*-------------------------------------------------------*/



